%%%%% fig10_4a.m %%%%% 
%	Jan. 99
%  last revision:  1/8/99  JHC
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
  disp('fig 10.4a: Initial condition response of observer-controller for Example 10.6')

  A = [-2 -2.5 -0.5; 1 0 0; 0 1 0];       % state matrix
  B = [ 1; 0; 0];                         % input matrix set to zero
  C = [1 4 3.5];                          % output matrix
  D = 0;                                  % throughput matrix
  Gp = ss(A,B,C,D)
  p_s = [-1 -2 -3];                       % desired system poles 
  F = place(A,B,p_s);                     % control gain
  p_o = [-3 -5 -7];
  L = place(A',C',p_o)';                  % estimator gain
  A_f = A-B*F-L*C ;                       % controller system matrix
  Gc = ss(A_f,-L,-F,0)
  %GcGp = Gc*Gp                           % cascade system
  GpGc = Gp*Gc                           % cascade system
  T = feedback(GpGc,1,-1)                % closed-loop system
  lfg = dcgain(T);
  N = 1/lfg;
  T_ref = N*T;
  %z0 = [0 0 0 1 -0.75 0.4]';
  z0 = [1 -0.75 0.4 0 0 0]';
  t = [0:0.02:4]';
  u = 0*t;
  [y,t,x] = lsim(T_ref,u,t,z0);
  plot(t,x(:,1:3),'--',t,x(:,4:6)), grid
  xlabel('Time (secs)'); ylabel('Amplitude')
  %title('fig 10.4a: Initial condition response of observer-controller for Example 10.6')
  text(0.23,0.85,'x1')
  text(0.9,0.4,'x1hat')
  text(0.55,-0.1,'x2')
  text(0.9,-0.3,'x2hat')
  text(0.6,0.05,'x3')
  text(1.4,0.18,'x3hat')
  print -deps fig10_4a.eps
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%