%%%%%%%%%%%%%%%%%%%%% wif10_5.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/15/99 HS
%----------------------------------------------------
%  This MATLAB file runs the What-if problem after 
%  		Example 10.5 (Observer design)
%----------------------------------------------------
clear,clf
  disp('What-if following ')
  disp('Example 10.5: Observer design')
  disp(' ')
  A = [-2 -2.5 -0.5; 1 0 0; 0 1 0];  % state matrix
  B = [ 0; 0; 0];                    % input matrix set to zero
  C = [1 4 3.5];                     % output matrix
  D = 0;                             % throughput matrix
  G = ss(A,B,C,D)
  p = [-3 -5 -7];
  p = 2*p
  disp('*****>');pause
  L = place(A',C',p)'               % estimator gain
  A_ob = A-L*C                      % observer system matrix
  eig(A_ob)                         % check eigenvalues
  disp('*****>');pause
  xo = [1; -0.75; 0.4]                   % initial conditions
  t = [0:0.04:4];                   % time array
  u = zeros(1,101);                 % zero input
  disp('*****>');pause
  [y,x] = lsim(G,u,t,xo);     % simulate system
  disp('Simulate Observer')
  G_ob = ss(A_ob,L,C,D)
  [y_hat,x_hat]=lsim(G_ob,y,t);  % simulate observer
  plot(t,x,'--',t,x_hat), grid
  title('WIF10.5: Observer State Response')
  xlabel('Time (secs)')
  ylabel('Amplitude')
  keyboard
  %
  plot(t,y,'-',t,y_hat,'--'), grid
  title('WIF10.5: Observer Output Response')
  xlabel('Time (secs)')
  ylabel('Amplitude')
  keyboard
  disp('end of What If 10.5')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%