%%%%%%%%%%%%%%%%%%%%%% cp2_3.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/23/99 HS
%----------------------------------------------------
%  .M file for analyzing the Open-loop rigid stick
%   example for Comprehensive Problem CP2.3
%----------------------------------------------------
disp('CP2.3: Open-loop rigid stick')
clear;clf
% load rigid.mat if exists, otherwise quit this M-file
if chkmat('rigid') == 1, 
    load rigid.mat
  else
     return
end
%
disp('G1(s) for u(t) --> theta')
numG1, denG1
G1 = tf(numG1,denG1)
disp('*******>');pause
[z1,p1,k1] = zpkdata(G1,'v')
disp('*******>');pause
[res1,pp1,other1] = residue(numG1,denG1)
disp('*******>');pause
%
disp('G2(s) for u(t) --> cart position ')
numG2, denG2
G2 = tf(numG2,denG2)
disp('*******>');pause
[z2,p2,k2] = zpkdata(G2,'v')
disp('*******>');pause
[res2,pp2,other2] = residue(numG2,denG2)
disp('*******>');pause
disp('end of Comprehensive Problem 2.3')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%