%%%%%%%%%%%%%%%%%%%%%% p2_7.m %%%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%              last revision: 5/23/99 HS
%----------------------------------------------------
% Problem 2.7: find zeros, poles, gain of a tf model,
%        and perform PFE and impulse response
% Also does responses due to real and complex poles
%    		separately:  ytot = ycplx + yreal
%   Uses special functions rpole2t & cpole2t
%----------------------------------------------------
clear, clf
disp('Problem 2.7: Third-order system with')
disp('              responses due to individual poles')
numG =[2 11 5]
denG = [1 7 32 60]
G = tf(numG,denG)
disp('*****>');pause
GG = zpk(G)
disp('*****>');pause
[zG,pG,kG] = zpkdata(G,'v')
disp('*****>');pause
[resG,polG,otherG] = residue(numG,denG)
disp('*****>');pause
t = [0:0.02:4]';
%%%-- response due to real and complex poles
ycmplx = cpole2t(polG(1),resG(1),t);
yreal = rpole2t(polG(3),resG(3),t);
ytot = ycmplx + yreal;
plot(t,ytot,t,ycmplx,'--',t,yreal,'-.');grid
title('P2.7: Total Response & Real(- -) & Complex (-.-.) Poles ')
keyboard
yy = impulse(numG,denG,t);
plot(t,ytot,t,yy); grid
title('P2.7: Impulse Response from G(s)')
disp('End of Reinforcement Problem 2.7')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%