%%%%%%%%%%%%%%%%%%%%%% p4_10.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/25/99 HS
%----------------------------------------------------
%    Problem 4.10: simulate general input response
%          of state-space model with nonzero 
%                 initial condition.
%----------------------------------------------------
  clear, clf
  disp('Problem 4.10: General Response')
  disp('Enter A, B, C, D matrices')
  A = [-7 -32 -60; 1 0 0; 0 1 0]
  B = [1; 0; 0], C = [2 11 5], D = 0
  G = ss(A,B,C,D)
  disp('*****>');pause
  t = [0:0.05:6]';
  disp('Enter initial condition')
  xo = [2; 0; 1]                 % initial condition
  u = ones(length(t),1);         % unit step
  disp('Simulate response due to input and initial condition')
  [y,t,x] = lsim(G,u,t,xo);  % response due to input and 
			         %   initial condition
  plot(t,x(:,1),'-',t,x(:,2),'--',t,x(:,3),'-.')
  grid;title('P4.10: State response, x(t)')
  xlabel('time (secs)')
  ylabel('Amplitude')
  keyboard
  plot(t,y)
  grid;title('P4.10: State response, y(t)')
  xlabel('time (secs)')
  ylabel('Amplitude')
  disp('end of Reinforcement Problem 4.10')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%