%%%%%%%%%%%%%%%%%%%%%% cp5_2c.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/28/99 HS
%----------------------------------------------------
%       Comprehensive Problem CP5.2c
%	     satellite + lead-lag control
%----------------------------------------------------
disp('CP5.2C: Satellite with lead-lag control')
clear;clf
% load sat.mat if exists, otherwise quit this M-file
if chkmat('sat') == 1, 
    load sat.mat
  else
     return
end
disp(' ')
numGp = numG1;	% rename to identify as plant
denGp = denG1;
Gp = tf(numGp,denGp)
disp('Have created TF model for satellite')
disp(' ')
disp('build model for satellite + lead-lag with alpha = 20')
disp('Book suggests s = -1 for zero location')
zlead = input('enter lead zero (< 0 for LHP) ==> ')
disp('Book suggests lag zero = 1/10 * lead zero')
zlag = input('enter lag zero (< 0 for LHP) ==> ')
%-- Note "-" before "conv" in next line ==> Kldlg is < 0
numGc = -conv([1  -zlag],[1  -zlead]);
denGc = conv([1  -zlag/20],[1  -20*zlead]);
Gc = tf(numGc,denGc)
GcGp = Gc*Gp;
disp('drawing root locus for lead with gain = -1')
disp('.....using default area')
rlocus(GcGp);grid
axis('equal')
title('CP5.2c: Satellite + lead-lag with gain = -1')
keyboard
disp('Using "axis([-35 5 -10 10])" for more detail')
axis([-35 5 -10 10])
keyboard
disp('Using "axis([-3 1 -1 1])" ')
axis([-3 1 -1 1])
keyboard
disp('Using "axis([-0.5 0.5 -0.2 0.2])"')
axis([-0.5 0.5 -0.2 0.2])
keyboard
disp('Using "axis([-0.05 0.05 -0.02 0.02])" ')
axis([-0.05 0.05 -0.02 0.02])
keyboard
%--- step response of unity-feedback closed-loop system
GcGp_CL = feedback(GcGp,1)
step(GcGp_CL);grid
title('CP5.2c: Closed-loop step response for K = -1')
disp('end of Comprehensive Problem 5.2c')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

