%%%%% fig6_1.m %%%%% 
%	Dec 98
% last revision: 12/28/1998, JHC
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
disp('fig 6.1: Example 6.1: Transient and Steady-state Response')
  G = tf([ 10 50 ],[ 1 4 3 ])
  t = [0:0.06:6]'; % time vector with 0.06 sec. increment
  u = 2*cos(5*t + 30*pi/180);  
  y = lsim(G,u,t);
  [mag,phase] = bode(G,5)  
  y_mag = 2 * mag
  y_phase = 30 + phase
  y_ss = 2*mag*cos (5*t + (30+phase)*pi/180);
  plot(t,u,'-',t,y,'--',t,y_ss,'-.')
  grid
  xlabel('Time (secs)')
  ylabel('Amplitude')
  text(1.3,-1.6,'u(t)')
  text(1.1,-5.5,'y(t)')
  text(0.4,4.4,'y_{ss}(t)')
  %title('fig 6.1: Transient and Steady-state Response u, y, yss')
  print -deps fig6_1.eps
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%