%%%%%%%%%%%%%%%%%%%%%% p6_6.m %%%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/28/99 HS
%----------------------------------------------------
%     Problem 6.6: make Bode, Nichols and Nyquist 
%    plots for a second order system with different
%                   damping ratio
%----------------------------------------------------
  clear,clf
  disp('Problem 6.6: Complex poles, different damping ratios')
  disp(' ')
  disp('Generate frequency response for different damping coefficients')
  disp('Make Bode plot')  
  zeta = [0.1; 0.4; 0.7; 1.0];
  magall = []; phaseall = []; w = logspace(-2,2,100)';
  for k =1:4
    numG = 1;
    denG = [1 2*zeta(k) 1];
    G = tf(numG,denG)
    [mag,phase] = bode(G,w);
    magall=[magall reshape(mag,[100,1])];
    phaseall=[phaseall reshape(phase,[100,1])];
  end
  subplot(2,1,1)
  semilogx(w,20*log10(magall)), grid
  xlabel('Frequency (rad/sec)')
  ylabel('Gain dB')
  title('P6.6: Bode plot')
  subplot(2,1,2)
  semilogx(w,phaseall), grid
  xlabel('Frequency (rad/sec)')
  ylabel('Phase deg')
  keyboard
  disp('Make Nichols plot')
  subplot(1,1,1)
  plot(phaseall(:,1),20*log10(magall(:,1)),phaseall(:,2),20*log10(magall(:,2)),...
       phaseall(:,3),20*log10(magall(:,3)),phaseall(:,4),20*log10(magall(:,4)))
  grid
  xlabel('Open-Loop Phase (deg)')
  ylabel('Open-Loop Gain (db)')
  title('P6.6: Nichols plot')
  keyboard
  disp('Make Nyquist plot')
  realall = magall.*cos(phaseall*pi/180);
  imagall = magall.*sin(phaseall*pi/180);
  xmax = max(max(realall)); xmin = min(min(realall));
  ymax = max(max(imagall)); ymin = min(min(imagall));
  if abs(ymax) >= abs(ymin) 
    if ymax >= ymin
      ymin = -ymax;
     else 
      ymin = ymax; ymax = -ymin;
    end
   else
    if ymax >= ymin
      ymax = -ymin;
     else
      ymax = ymin; ymin = -ymax;
    end
  end 
  axis([xmin,xmax,ymin,ymax])
  plot(realall(:,1),imagall(:,1),realall(:,2),imagall(:,2),...
       realall(:,3),imagall(:,3),realall(:,4),imagall(:,4))
  hold on
  plot(realall(:,1),-imagall(:,1),'--',realall(:,2),-imagall(:,2),'--',...
       realall(:,3),-imagall(:,3),'--',realall(:,4),-imagall(:,4),'--')
  grid
  xlabel('Real Axis')
  ylabel('Imag Axis')
  title('P6.6: Nyquist plot')
  keyboard
  hold off
  disp('end of Reinforcement Problem 6.6')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%