%%%%%%%%%%%%%%%%%%%%% wif6_1.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/28/99 HS
%----------------------------------------------------
%  This MATLAB file runs the What-if problem after 
%  Example 6.1 (Sinusoidal Steady-state Response) 
%----------------------------------------------------
clear,clf
  disp('What-if following ')
  disp('Example 6.1: Sinusoidal Steady-state response')
  %   
  disp(' ')
  disp('Enter transfer-function coefficients')
  numG = [ 10 50 ]
  denG = [ 1 4 3 ]
  G = tf(numG,denG)
  disp('*****>');pause
  disp('Set up t, u and y.')
  disp('The input sinusoidal signal has a frequency of 1 rad/s.')
  disp('Use a longer time (t=20 s) for simulation. ')
  t = [0:0.2:20]'; % time vector with 0.2 sec. increment
  u = 2*cos(t + 30*pi/180);  
  y = lsim(G,u,t);
  disp('magnitude and phase of frequency response at w = 1 rad/s')
  [mag,phase] = bode(G,1)  
  disp('*****>');pause
  disp('magnitude and phase of steady-state response')
  y_mag = 2 * mag
  y_phase = 30 + phase
  y_ss = 2*mag*cos (t + (30+phase)*pi/180);
  plot(t,u,'-',t,y,'--',t,y_ss,'-.')
  grid, title('WIF6.1 : u (solid), y (dashed) & yss (dashdot)')
  xlabel('Time (secs)')
  ylabel('u, y, yss')
  text(3,1,'u(t)')
  text(0.3,11,'y(t)')
  text(2.0,11,'yss(t)')
  disp('Note: the magnitude of the output is larger and')
  disp('... the phase delay is smaller.')
  keyboard

  disp('Continuing with the What-if Problem following ')
  disp('Example 6.1: Sinusoidal Steady-state response')
  %   
  disp(' ')
  disp('Enter transfer-function coefficients')
  numG = [ 10 50 ]
  denG = [ 1 4 3 ]
  G = tf(numG,denG)
  disp('*****>');pause
  disp('Set up t, u and y.')
  disp('The input sinusoidal signal has a frequency of 20 rad/s.')
  disp('Use a shorter time (t = 3 s) for simulation. ')
  t = [0:0.015:3]'; % time vector with 0.06 sec. increment
  u = 2*cos(20*t + 30*pi/180);  
  y = lsim(G,u,t);
  disp('magnitude and phase of frequency response at w = 20 rad/s')
  [mag,phase] = bode(G,20)  
  disp('*****>');pause
  disp('magnitude and phase of steady-state response')
  y_mag = 2 * mag
  y_phase = 30 + phase
  y_ss = 2*mag*cos (20*t + (30+phase)*pi/180);
  plot(t,u,'-',t,y,'--',t,y_ss,'-.')
  grid, title('WIF6.1 : u (solid), y (dashed) & yss (dashdot)')
  xlabel('Time (secs)')
  ylabel('u, y, yss')
  text(0.15,1.3,'u')
  text(0.3,-1.3,'y')
  text(0.3,0.8,'yss')
  disp('Note: the magnitude of the output is smaller and')
  disp('... the phase delay is larger.')
  keyboard
  disp('end of What If 6.1')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

