%%%%% fig7_5.m %%%%% 
%	Jan. 1999
%  last revision: 1/2/99  JHC
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
disp('fig 7.5: Magnitude plots of T(jw) and S(jw) for Example 7.3')
  denGp = conv(conv([1 0.01],[1 1]),[1 20])  % generate Gp(s)
  Gp = tf(1,denGp)
  G  = 50*Gp				     % series connection 
  Tr = feedback(G,1)           % CL transfer function T(s)
  bode(Tr)
  plt_ttl('Bode Diagrams',' ')
  title('Ex 7.3: CL transfer function frequency response')
  [mag_CL,ph_CL,w] = bode(Tr);             % frequency response
  mag_CLdB = 20*log10(mag_CL);             % gain in dB
  lfg_CL = dcgain(Tr)                      % dc gain
  lfg_CL = 20*log10(lfg_CL);
  BW = bwcalc(mag_CLdB,w,lfg_CL)           % bandwidth
  [M_pw,i] = max(mag_CLdB)                 % maximum freq. resp.
  wp = w(i)                                
  S = feedback(1,G) 			   % S(s)
  [magS,phS] = bode(S,w);                  % sensitivity
  magS_dB = 20*log10(magS);
  [maxS,j] = max(magS_dB);
  w(j)
  subplot(1,1,1)
  semilogx(w,mag_CLdB(:),'-',w,magS_dB(:),'--'), grid
  %title('fig 7.5 : Magnitude plots of T(jw) and S(jw)')
  xlabel('Frequency (rad/sec)')
  ylabel('Gain dB')
  text(12,5,'Sensitivity')
  text(12,-4,'peak = 6.45 dB')
  text(12,-9,'  at 1.80 rad/s')
  text(1.2,-43,'Magnitude response')
  text(1.2,-53,'CL bandwidth = 2.32 rad/s')
  text(1.2,-58,'Mp = 5.37 dB')
  text(1.2,-63,'wp = 1.52 rad/s') 
  print -deps fig7_5.eps
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%