%%%%%%%%%%%%%%%%%%%%% wif7_1a.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%  This MATLAB file runs the What-if problem after 
%  Example 7.1 (Step-Response Performance)
%----------------------------------------------------
clear,clf
  disp('What-if Part (a) following ')
  disp('Example 7.1: Step response specifications')
  disp(' ')
  format short e 
  denGp = conv(conv([1 0.01],[1 1]),[1 20])
  Gp = tf(1,denGp)
  Gcp = 100*Gp
  disp('*****>');pause
  Tr = feedback(Gcp,1)
  t = [0:0.05:20]';
  y = step(Tr,t);
  clf, plot(t,y); grid
  ylabel('y(t)');xlabel('Time (sec)')
  title('WIF7.1a: Step response of third order system')
  [pos,tp,tr,ts,ess] = tstats(t,y,1.0);
  text(2,0.50,['overshoot = ' num2str(pos) ' %'],'sc')
  text(2,0.40,['time to overshoot = ' num2str(tp) ' s'],'sc')
  text(2,0.30,['rise time = ' num2str(tr) ' s'],'sc')
  text(2,0.20,['2pct settling time = ' num2str(ts) ' s'],'sc')
  text(2,0.10,['steady-state error = ' num2str(ess) ' %'],'sc')
  damp(Tr)
  [numTr,denTr] = tfdata(Tr,'v')
  [resS,polS,otherS] = residue(numTr,[denTr 0])
  keyboard
  Td = feedback(Gp,100)
  step(Td,t)
  grid
  title('WIF7.1a: Disturbance response of third order system')
  keyboard
  disp('end of What If 7.1a')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
