%%%%%%%%%%%%%%%% fig8_3c.m %%%%%%%%%%%%%%%
%
%      2nd order plant with 2 real poles with P-only control
%	Does parameter sweep on KP with specified value of KI
% 	draws figure 8.3(c)
%  	Jan 99
%   last revision:  1/6/99  JHC
%----------------------------------------
clear;
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
disp('fig 8.3(c): PI control, KI = 1.00')
tauP1 = 2; tauP2 = 0.5; tau_sen = 0.05; Kproc = 4;
denGp = conv([tauP1 1],[tauP2 1]);
Gp    = tf(Kproc,denGp)
H     = tf(1,[tau_sen 1])
t = [0:0.02:10]';
KI = 1.00;
KI_str=num2str(KI);
  for KP = [0.3:0.2:1.7];
    Kc = tf(KP*[1 KI],[1 0]);
    T = feedback(Kc*Gp,H,-1)
    ys = step(T,t);
    plot(t,ys)
    if ishold ~=  1, hold on, end
  end	
xlabel('Time (sec.)'),ylabel('Amplitude')
grid;
% title('fig 8.3c: CL step response, P + I control, ref input')
text(5.0,0.25,'KP = 0.3,0.5, ... ,1.7')
text(5.0,0.15,['KI = ' KI_str])
hold off
text(1.50,1.55,'KP = 1.7')
text(1.55,0.50,'KP = 0.3')
print -deps fig8_3c.eps
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%