%%%%%%%%%%%%%%%%%%%%% wif8_2a.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/16/99 HS
%----------------------------------------------------
%  This MATLAB file runs the What-if problem after 
%  						Example 8.2
%----------------------------------------------------
clear,clf
disp('Wif 8.2a: PI control')
%----- plant & sensor parameters
tauP1 = 2; tauP2 = 0.5; tau_sen = 0.05; Kproc = 4;
denGp = conv([tauP1 1],[tauP2 1]);
Gp    = tf(Kproc,denGp)
H     = tf(1,[tau_sen 1])
%---------- open-loop transfer function
GpH   = Gp*H;

disp('Root Locus for KI = 0.25')
KI = 0.25;	
KI_str=num2str(KI);
Kc = tf([1 KI],[1 0]);
T = feedback(Kc*Gp,H,-1);
%--- do root locus for KP = 1
disp('first with default area')
Kc = tf([1 KI],[1 0]);
rlocus(Kc*Gp*H)
grid
axis equal
title('Wif 8.2a: root locus for PI control, KI = 0.25')
text(-40,-25,['KI = ' KI_str])
keyboard
disp('use smaller area for details near origin')
axis([-8 2 -2 8])
text(-6,1,['KI = ' KI_str])
keyboard
[kk,polesCL] = rlocfind(Kc*Gp*H)
keyboard

disp('Root Locus for KI = 1.0')
KI = 1;	
KI_str=num2str(KI);
Kc = tf([1 KI],[1 0]);
T = feedback(Kc*Gp,H,-1);
%--- do root locus for KP = 1
disp('first with default area')
Kc = tf([1 KI],[1 0]);
rlocus(Kc*Gp*H)
grid
axis equal
title('Wif 8.2a: root locus for PI control, KI = 1.0')
text(-40,-25,['KI = ' KI_str])
keyboard
disp('use smaller area for details near origin')
axis([-6 2 -2 6])
text(-5,1,['KI = ' KI_str])
keyboard
[kk,polesCL] = rlocfind(Kc*Gp*H)
keyboard
disp('end of What If 8.2a')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%